#include "stdafx.h"
#include "SumomoCopy.h"
#include "SumomoCopyDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define DST_LIST_MAX 20

CSumomoCopyDlg::CSumomoCopyDlg (CWnd* pParent) :
	CDialog (CSumomoCopyDlg::IDD, pParent),
	m_hIcon (AfxGetApp()->LoadIcon (IDR_MAINFRAME)),
	m_uQueryCancelAutoPlay (0)
{
}

void CSumomoCopyDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_SRC_LIST, m_SrcList);
	DDX_Control(pDX, IDC_DST_LIST, m_DstList);
}

BEGIN_MESSAGE_MAP(CSumomoCopyDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_NOTIFY(NM_DBLCLK, IDC_SRC_LIST, OnNMDblclkSrcList)
	ON_WM_TIMER()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_NOTIFY(NM_RCLICK, IDC_SRC_LIST, OnNMRclickSrcList)
	ON_BN_CLICKED(IDBROWSE, OnBnClickedBrowse)
	ON_WM_DEVMODECHANGE()
	ON_BN_CLICKED(IDC_OPEN, OnBnClickedOpen)
END_MESSAGE_MAP()

BOOL DoAction (TCHAR Drive, int type)
{
	BOOL res = FALSE;
	TCHAR name [] = _T("\\\\.\\$:");
	name [4] = Drive;
	HANDLE h = CreateFile (name, GENERIC_READ, FILE_SHARE_READ | FILE_SHARE_WRITE,
		NULL, OPEN_EXISTING, 0, NULL);
	if (h != INVALID_HANDLE_VALUE) {
		DWORD dwBytesReturned;
		res = DeviceIoControl (h, type, NULL, 0, NULL, 0, &dwBytesReturned, NULL);
		CloseHandle (h);
	}
	return res;
}

inline BOOL EjectDrive (TCHAR Drive)
{
	CWaitCursor wc;
	return DoAction (Drive, IOCTL_DISK_EJECT_MEDIA);
}

inline BOOL LoadDrive (TCHAR Drive)
{
	CWaitCursor wc;
	return DoAction (Drive, IOCTL_DISK_LOAD_MEDIA);
}

inline BOOL DriveStatus (TCHAR Drive)
{
	return DoAction (Drive, IOCTL_DISK_CHECK_VERIFY);
}

BOOL CSumomoCopyDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);
	SetIcon(m_hIcon, FALSE);

	VERIFY (m_SrcImgList.Create (16, 16, ILC_MASK | ILC_COLOR32, 5, 0));
	VERIFY (m_DstImgList.Create (16, 16, ILC_MASK | ILC_COLOR32, 20, 0));

	m_SrcList.SetExtendedStyle (m_SrcList.GetExtendedStyle () | LVS_EX_FULLROWSELECT |
		LVS_EX_CHECKBOXES | LVS_EX_LABELTIP);
	CRect rcSrcList;
	m_SrcList.GetClientRect (&rcSrcList);
	CString tmp;
	tmp.LoadString (IDS_DRIVE);
	m_SrcList.InsertColumn (0, tmp, LVCFMT_LEFT, 180);
	tmp.LoadString (IDS_STATUS);
	m_SrcList.InsertColumn (1, tmp, LVCFMT_LEFT,
		rcSrcList.Width () - GetSystemMetrics (SM_CXVSCROLL) - 182);
	m_SrcList.SetImageList (&m_SrcImgList, LVSIL_SMALL);

	TCHAR name [] = _T("\\\\.\\$:\\");
	LVITEM it;
	ZeroMemory (&it, sizeof (it));
	it.mask = LVIF_PARAM;
	for (TCHAR c = _T('A'); c <= _T('Z'); ++c/*, bit <<= 1*/) {
		name [4] = c;
		if (GetDriveType (name) == DRIVE_CDROM) {
			drive_info* di = new drive_info;
			di->Drive = c;
			di->Status = (drive_status) -1;
			di->SerialNumber = (DWORD) -1;
			di->Thread = NULL;
			di->strDst.Empty ();
			di->hwndParent = GetSafeHwnd ();
			it.lParam = reinterpret_cast <LPARAM> (di);
			int i = m_SrcList.InsertItem (&it);
			SetStatus (i, DS_IDLE);

			it.iItem ++;
		}
	}

	VERIFY (SUCCEEDED (SHAutoComplete (m_DstList.GetEditCtrl ()->GetSafeHwnd (),
		SHACF_AUTOAPPEND_FORCE_ON | SHACF_AUTOSUGGEST_FORCE_ON | SHACF_FILESYSTEM)));
	m_DstList.SetImageList (&m_DstImgList);
	LoadDestinations ();
	UpdateDestinations ();

	m_uQueryCancelAutoPlay = RegisterWindowMessage (TEXT ("QueryCancelAutoPlay"));
	ASSERT (m_uQueryCancelAutoPlay);

	SHSetValue (HKEY_LOCAL_MACHINE, _T("SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Explorer\\AutoplayHandlers\\CancelAutoplay\\CLSID"),
		_T("00000000-0000-0000-0000-000000000000"), REG_SZ, _T(""), 0);

	m_uTimer = SetTimer (1, 1500, NULL);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSumomoCopyDlg::OnPaint() 
{
	if (IsIconic ()) {
		CPaintDC dc(this);
		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;
		dc.DrawIcon (x, y, m_hIcon);
	} else
		CDialog::OnPaint();
}

HCURSOR CSumomoCopyDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CSumomoCopyDlg::OnNMDblclkSrcList (NMHDR* /*pNMHDR*/, LRESULT *pResult)
{
	CPoint ptCursor;	
	GetCursorPos (&ptCursor);
	m_SrcList.ScreenToClient (&ptCursor);
	UINT nFlags;
	int index = m_SrcList.HitTest (ptCursor, &nFlags);
	if (index != -1) {
		drive_info* di = reinterpret_cast <drive_info*> (m_SrcList.GetItemData (index));
		if (DriveStatus (di->Drive))
			EjectDrive (di->Drive);
		else
			LoadDrive (di->Drive);
	}
	*pResult = 0;
}

BOOL CSumomoCopyDlg::OnWndMsg (UINT message, WPARAM wParam, LPARAM lParam, LRESULT* pResult)
{
	if (message == m_uQueryCancelAutoPlay) {
		TRACE ("WM_QueryCancelAutoPlay\n");
		SetWindowLong (GetSafeHwnd (), DWL_MSGRESULT, TRUE);
		*pResult = 1;
		return TRUE;
	}
	return CDialog::OnWndMsg(message, wParam, lParam, pResult);
}

void CSumomoCopyDlg::OnDevModeChange(LPTSTR lpDeviceName)
{
	TRACE ("WM_DEVICECHANGE : %s\n", lpDeviceName);
	CDialog::OnDevModeChange(lpDeviceName);
}

void CSumomoCopyDlg::OnTimer(UINT nIDEvent)
{
	CDialog::OnTimer(nIDEvent);

	Process ();
}

void CSumomoCopyDlg::OnDestroy()
{
	KillTimer (m_uTimer);
	m_uTimer = 0;
	
	int size = m_SrcList.GetItemCount ();
	for (int i = 0; i < size; ++i) {
		drive_info* di = reinterpret_cast <drive_info*> (m_SrcList.GetItemData (i));
		if (di && di->Thread) {
			TerminateThread (di->Thread, 1);
			CloseHandle (di->Thread);
			di->Thread = NULL;
		}
		delete di;
	}

	//    
	CString strDst;
	m_DstList.GetWindowText (strDst);
	if (CheckDestination (strDst, FALSE))
		InsertDestination (strDst, 0);

	//  
	SaveDestinations ();

	SHDeleteValue (HKEY_LOCAL_MACHINE, _T("SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Explorer\\AutoplayHandlers\\CancelAutoplay\\CLSID"),
		_T("00000000-0000-0000-0000-000000000000"));

	CDialog::OnDestroy();
}

void CSumomoCopyDlg::SetStatus (int i, drive_status new_status)
{
	LVITEM it;
	ZeroMemory (&it, sizeof (it));
	it.iItem = i;

	drive_info* di = reinterpret_cast <drive_info*> (m_SrcList.GetItemData (i));
	TCHAR name [] = _T("\\\\.\\$:\\");
	name [4] = di->Drive;

	TCHAR Label [MAX_PATH] = { _T('\0') };
	DWORD SerialNumber = 0;
	BOOL vi = GetVolumeInformation (name, Label, MAX_PATH, &SerialNumber,
		NULL, NULL, NULL, 0);

	if (di->SerialNumber != SerialNumber) {
		di->SerialNumber = SerialNumber;

		it.mask |= LVIF_IMAGE;
		SHFILEINFO sfi;
		ZeroMemory (&sfi, sizeof (sfi));
		SHGetFileInfo (&name [4], 0, &sfi, sizeof (sfi), SHGFI_DISPLAYNAME |
			SHGFI_ADDOVERLAYS | SHGFI_ICON | SHGFI_SMALLICON);
		if (!sfi.hIcon)
			sfi.hIcon = AfxGetApp()->LoadIcon (IDI_CD);
		if (m_SrcImgList.GetImageCount () <= i)
			it.iImage = m_SrcImgList.Add (sfi.hIcon);
		else
			it.iImage = m_SrcImgList.Replace (i, sfi.hIcon);
		ASSERT (it.iImage == i);
		DestroyIcon (sfi.hIcon);

		it.mask |= LVIF_TEXT;
		if (!vi)
			it.pszText = sfi.szDisplayName;
		else {
			name [2] = _T(' ');
			name [3] = _T('(');
			name [6] =  _T(')');
			lstrcat (Label, &name [2]);
			it.pszText = Label;
		}
	}

	if (it.mask)
		m_SrcList.SetItem (&it);

	if (di->Status != new_status) {
		di->Status = new_status;
		CString strStatus;
		strStatus.LoadString (IDS_DS_IDLE + di->Status);
		m_SrcList.SetItemText (i, 1, strStatus);
	}

	UpdateWindow ();
}

void CSumomoCopyDlg::UpdateDestinations ()
{
	COMBOBOXEXITEM cbi;
	ZeroMemory (&cbi, sizeof (cbi));
	cbi.mask = CBEIF_IMAGE | CBEIF_SELECTEDIMAGE;
	CString path;
	for (int i = 0; i < m_DstList.GetCount (); ++i) {
		m_DstList.GetLBText (i, path);
		SHFILEINFO sfi;
		ZeroMemory (&sfi, sizeof (sfi));
		SHGetFileInfo (path, 0, &sfi, sizeof (sfi),
			SHGFI_ADDOVERLAYS | SHGFI_ICON | SHGFI_SMALLICON);
		if (!sfi.hIcon)
			sfi.hIcon = AfxGetApp()->LoadIcon (IDI_PATH);
		if (m_DstImgList.GetImageCount () <= i)
			cbi.iSelectedImage = cbi.iImage = m_DstImgList.Add (sfi.hIcon);
		else
			cbi.iSelectedImage = cbi.iImage = m_DstImgList.Replace (i, sfi.hIcon);
		ASSERT (cbi.iImage == i);
		DestroyIcon (sfi.hIcon);
		cbi.iItem = i;
		m_DstList.SetItem (&cbi);
	}
	m_DstList.UpdateWindow ();
}

void CSumomoCopyDlg::InsertDestination (LPCTSTR path, int i)
{
	//   
	int size;
	while ((size = m_DstList.GetCount ()) >= DST_LIST_MAX) {
		m_DstList.DeleteString (size - 1);
		m_DstImgList.Remove (size - 1);
	}

	//  
	int j;
	while ((j = m_DstList.FindStringExact (0, path)) != CB_ERR) {
		m_DstList.DeleteString (j);
		m_DstImgList.Remove (j);
	}

	//  
	COMBOBOXEXITEM cbi;
	ZeroMemory (&cbi, sizeof (cbi));
	cbi.mask = CBEIF_TEXT;
	cbi.iItem = i;
	cbi.pszText = (LPTSTR) path;
	m_DstList.InsertItem (&cbi);
}

void CSumomoCopyDlg::SaveDestinations ()
{
	CString strValue, strTmp;
	int size = m_DstList.GetCount ();
	for (int i = 0; i < size; ++i) {
		strValue.Format (_T("Destination%02d"), i);
		m_DstList.GetLBText (i, strTmp);
		SHSetValue (HKEY_CURRENT_USER, _T("Software\\SumomoCopy"), strValue, REG_SZ,
			strTmp, strTmp.GetLength () * sizeof (TCHAR));
	}
}

void CSumomoCopyDlg::LoadDestinations ()
{
	CString strValue, strTmp;
	DWORD dwType, dwSize, res;
	for (int i = 0; i < DST_LIST_MAX; ++i) {
		strValue.Format (_T("Destination%02d"), i);
		dwSize = MAX_PATH * sizeof (TCHAR);
		res = SHGetValue (HKEY_CURRENT_USER, _T("Software\\SumomoCopy"),
			strValue, &dwType, strTmp.GetBuffer (MAX_PATH), &dwSize);
		strTmp.ReleaseBuffer ();
		if (res != ERROR_SUCCESS || dwType != REG_SZ || dwSize == 0)
			break;
		InsertDestination (strTmp, i);
	}
	m_DstList.SetCurSel (0);
}

BOOL CSumomoCopyDlg::CheckDestination (CString& strDst, BOOL check)
{
	//   
	strDst = strDst.Trim ().TrimRight (_T("\\//"));
	if (strDst.IsEmpty () || strDst.FindOneOf (_T("?*<>|\"")) != -1)
		return FALSE;
	if (strDst [strDst.GetLength () - 1] != _T('\\'))
		strDst += _T("\\");

	//    
	if (check) {
		HRESULT res = SHPathPrepareForWrite (GetSafeHwnd (), NULL, strDst,
			SHPPFW_DIRCREATE);
		if (res != S_OK)
			return FALSE;
	}

	return TRUE;
}

//   
BOOL CSumomoCopyDlg::GetDestination (CString& strDst, BOOL check)
{
	m_DstList.GetWindowText (strDst);

	if (!CheckDestination (strDst, check))
		return FALSE;

	//    
	InsertDestination (strDst, 0);
	m_DstList.SetCurSel (0);

	UpdateDestinations ();
	SaveDestinations ();

	return TRUE;
}

DWORD WINAPI CSumomoCopyDlg::CopyThread (LPVOID param)
{
	CoInitialize (NULL);
	drive_info* di = reinterpret_cast <drive_info*> (param);
	SHFILEOPSTRUCT fo;
	ZeroMemory (&fo, sizeof (fo));
	fo.hwnd = di->hwndParent;
	fo.wFunc = FO_COPY;
	TCHAR from [] = _T("$:\\*.*\0\0");
	from [0] = di->Drive;
	fo.pFrom = from;
	di->strDst.Append (_T("\0\0"), 2);
	fo.pTo = di->strDst;
	SHFileOperation (&fo);
	CoUninitialize ();
	return 0;
}

DWORD WINAPI CSumomoCopyDlg::LoadThread (LPVOID param)
{
	CoInitialize (NULL);
	drive_info* di = reinterpret_cast <drive_info*> (param);
	if (!DriveStatus (di->Drive))
		LoadDrive (di->Drive);
	CoUninitialize ();
	return 0;
}

DWORD WINAPI CSumomoCopyDlg::EjectThread (LPVOID param)
{
	CoInitialize (NULL);
	drive_info* di = reinterpret_cast <drive_info*> (param);
	EjectDrive (di->Drive);
	CoUninitialize ();
	return 0;
}

void CSumomoCopyDlg::Process ()
{
	DWORD id;
	int size = m_SrcList.GetItemCount ();
	for (int i = 0; i < size; ++i) {
		drive_info* di = reinterpret_cast <drive_info*> (m_SrcList.GetItemData (i));
		if (di->Thread && WaitForSingleObject (di->Thread, 0) == WAIT_TIMEOUT)
			//     
			continue;
		if (di->Thread) {
			CloseHandle (di->Thread);
			di->Thread = NULL;
		}
		if (m_SrcList.GetCheck (i)) {
			switch (di->Status) {
				case DS_IDLE:
					SetStatus (i, DS_WAIT_FOR_LOAD);
					di->Thread = CreateThread (NULL, 0, LoadThread, di, 0, &id);
					break;

				case DS_EJECT:
					SetStatus (i, DS_WAIT_FOR_LOAD);
					di->Thread = CreateThread (NULL, 0, EjectThread, di, 0, &id);
					break;

				case DS_WAIT_FOR_LOAD:
					//   
					if (DriveStatus (di->Drive)) {
						if (GetDestination (di->strDst, TRUE)) {
							//  
							SetStatus (i, DS_COPY);
							di->Thread = CreateThread (NULL, 0, CopyThread, di, 0, &id);
						} else
							m_SrcList.SetCheck (i, FALSE);
					}
					break;

				case DS_COPY:
					//  
					SetStatus (i, DS_EJECT);								
					break;
			}
		} else
			if (di->Status != DS_COPY)
				SetStatus (i, DS_IDLE);
	}
}

void CSumomoCopyDlg::OnBnClickedOk ()
{
}

void CSumomoCopyDlg::OnNMRclickSrcList (NMHDR* /* pNMHDR */, LRESULT *pResult)
{
	//     
	CPoint ptCursor;	
	GetCursorPos (&ptCursor);
	m_SrcList.ScreenToClient (&ptCursor);
	UINT nFlags;
	int i = m_SrcList.HitTest (ptCursor, &nFlags);
	if (i != -1) {
		drive_info* di = reinterpret_cast <drive_info*> (m_SrcList.GetItemData (i));
		TCHAR from [] = _T("$:\\");
		from [0] = di->Drive;
		c4u::context menu;
		menu.DoExplorerMenu (GetSafeHwnd (), from, ptCursor);
	}

	*pResult = 0;
}

void CSumomoCopyDlg::OnBnClickedBrowse()
{
	CString strDst;
	m_DstList.GetWindowText (strDst);

	LPMALLOC g_pMalloc = NULL;
	if (SUCCEEDED (SHGetMalloc (&g_pMalloc))) {
		LPITEMIDLIST pidl;
		SHGetSpecialFolderLocation (GetSafeHwnd (), CSIDL_DRIVES, &pidl);
		BROWSEINFO bi;
		bi.hwndOwner = GetSafeHwnd ();
		bi.pidlRoot = pidl;
		TCHAR szDisplayName [MAX_PATH];
		bi.pszDisplayName = szDisplayName;
		CString strTitle;
		strTitle.LoadString (IDS_BROWSE_HINT);
		bi.lpszTitle = strTitle; 
		bi.ulFlags = BIF_RETURNFSANCESTORS | BIF_RETURNONLYFSDIRS |
			BIF_NEWDIALOGSTYLE | BIF_UAHINT; 
		bi.lpfn = NULL;
		bi.lParam = 0;
		LPITEMIDLIST pidlBrowse = SHBrowseForFolder (&bi);
		if (pidlBrowse) {
			BOOL ret = SHGetPathFromIDList (pidlBrowse, strDst.GetBuffer (MAX_PATH));
		    g_pMalloc->Free (pidlBrowse); 
			strDst.ReleaseBuffer ();
			if (ret && !strDst.IsEmpty ()) {
				m_DstList.SetWindowText (strDst);
				GetDestination (strDst, FALSE);
			}
		}		
	    g_pMalloc->Free (pidl); 
		g_pMalloc->Release ();
	}
}

void CSumomoCopyDlg::OnBnClickedOpen()
{
	CString strDst;
	m_DstList.GetWindowText (strDst);
	ShellExecute (GetSafeHwnd (), NULL, strDst, NULL, NULL, SW_NORMAL);
}
