#pragma once

class CSumomoCopyDlg : public CDialog
{
public:
	CSumomoCopyDlg (CWnd* pParent = NULL);

	enum { IDD = IDD_SUMOMOCOPY_DIALOG };

protected:
	typedef enum {
		DS_IDLE = 0,					// 	
		DS_EJECT,						//   
		DS_WAIT_FOR_LOAD,				//   
		DS_COPY							// 
	} drive_status;
	typedef struct {
		TCHAR			Drive;			//  
		drive_status	Status;			//     
		DWORD			SerialNumber;	//   
		HANDLE			Thread;			//   
		CString			strDst;			//   
		HWND			hwndParent;		//   
	} drive_info;

	HICON m_hIcon;
	CListCtrl m_SrcList;
	CComboBoxEx m_DstList;
	CImageList m_SrcImgList;
	CImageList m_DstImgList;
	UINT m_uQueryCancelAutoPlay;
	UINT_PTR m_uTimer;

	void SetStatus (int i, drive_status new_status);
	BOOL GetDestination (CString& strDst, BOOL check);
	static DWORD WINAPI CopyThread (LPVOID param);
	static DWORD WINAPI LoadThread (LPVOID param);
	static DWORD WINAPI EjectThread (LPVOID param);
	void Process ();
	BOOL CheckDestination (CString& strDst, BOOL check);
	void SaveDestinations ();
	void LoadDestinations ();
	void InsertDestination (LPCTSTR path, int i);
	void UpdateDestinations ();

	virtual BOOL OnInitDialog();
	virtual void DoDataExchange(CDataExchange* pDX);
	virtual BOOL OnWndMsg(UINT message, WPARAM wParam, LPARAM lParam, LRESULT* pResult);
	
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnNMDblclkSrcList(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnDestroy();
	afx_msg void OnBnClickedOk();
	afx_msg void OnNMRclickSrcList(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnBnClickedBrowse();
	afx_msg void OnDevModeChange(LPTSTR lpDeviceName);

	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnBnClickedOpen();
};
